%define _buildid .21

%global py26nvr python26-pip-%{version}-%{release}
%global py26builddir %{_builddir}/%{py26nvr}
%global py26doc ../%{py26nvr}

%global py27nvr python27-pip-%{version}-%{release}
%global py27builddir %{_builddir}/%{py27nvr}
%global py27doc ../%{py27nvr}

%global py34nvr python34-pip-%{version}-%{release}
%global py34builddir %{_builddir}/%{py34nvr}
%global py34doc ../%{py34nvr}

%bcond_without tests # with

%global upstream_name pip

Name: python-pip
Version: 6.1.1
Release: 1%{?_buildid}%{?dist}
Summary: A tool for installing and managing Python packages
Group: Development/Libraries
License: MIT
URL: http://www.pip-installer.org
Source0: http://pypi.python.org/packages/source/p/pip/%{upstream_name}-%{version}.tar.gz
# Amazon patches
Patch0: python-pip-remove-ca-bundle.patch
Patch1: python-pip-unvendor-ssl_match_hostname.patch
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: python26
BuildRequires: python27
BuildRequires: python34

%description
Pip is a replacement for `easy_install
<http://peak.telecommunity.com/DevCenter/EasyInstall>`_.  It uses mostly the
same techniques for finding packages, so packages that were made
easy_installable should be pip-installable as well.

%package -n python26-pip
Summary: A tool for installing and managing Python packages
BuildRequires: python26-devel
BuildRequires: python26-setuptools
Requires: python26(alternatives)
Requires: alternatives(addslave)
Requires: alternatives(removeslave)
Requires: alternatives(force)
Requires(preun): python26(alternatives)
Requires(preun): alternatives(removeslave)
Requires: ca-certificates
Requires: python26-setuptools

# Additional requirements for python-2.6
Requires: python26-backports-ssl_match_hostname
Provides: python-pip = %{version}-%{release}
# Packages bundled/vendored by pip
# Rationale: https://github.com/pypa/pip/blob/develop/pip/_vendor/README.rst
# Versions are listed in pip/_vendor/vendor.txt
Provides: bundled(python-distlib) = 0.2.0
Provides: bundled(python-html5lib) = 0.999
Provides: bundled(python-six) = 1.9.0
Provides: bundled(python-colorama) = 0.3.3
Provides: bundled(python-CacheControl) = 0.11.2
Provides: bundled(python-lockfile) = 0.10.2
Provides: bundled(python-progress) = 1.2
Provides: bundled(python-ipaddress) = 1.0.7
Provides: bundled(python-packaging) = 15.0
Provides: bundled(python-retrying) = 1.3.3

# requests bundles lots of things on its own
Provides: bundled(python-requests) = 2.6.0
Provides: bundled(python-chardet) = 2.3.0
# requests 2.6.0 uses urllib3 43b5b2b452e4344374de7d08ececcca495079b8d
# which is the 16th commit after tag 1.10.2
# https://github.com/shazow/urllib3/compare/1.10.2...1.10.3
Provides: bundled(python-urllib3) = 1.10.2
Provides: bundled(python-six) = 1.2.0
# ordered_dict.py from http://code.activestate.com/recipes/576693/, no versioning data
Provides: bundled(python-ordereddict)
Obsoletes: python-pip <= 1.3.1-4.9.amzn1

%description -n python26-pip
Pip is a replacement for `easy_install
<http://peak.telecommunity.com/DevCenter/EasyInstall>`_.  It uses mostly the
same techniques for finding packages, so packages that were made
easy_installable should be pip-installable as well.

This package is meant to be used with Python 2.6.

%package -n python27-pip
Summary: A tool for installing and managing Python packages
BuildRequires: python27-devel
BuildRequires: python27-setuptools
Requires: python27(alternatives)
Requires: alternatives(addslave)
Requires: alternatives(removeslave)
Requires: alternatives(force)
Requires(preun): python27(alternatives)
Requires(preun): alternatives(removeslave)
Requires: ca-certificates
Requires: python27-setuptools

# Ensure we have ssl.match_hostname
Requires: python27 >= 2.7.9
# Packages bundled/vendored by pip
# Rationale: https://github.com/pypa/pip/blob/develop/pip/_vendor/README.rst
# Versions are listed in pip/_vendor/vendor.txt
Provides: bundled(python-distlib) = 0.2.0
Provides: bundled(python-html5lib) = 0.999
Provides: bundled(python-six) = 1.9.0
Provides: bundled(python-colorama) = 0.3.3
Provides: bundled(python-CacheControl) = 0.11.2
Provides: bundled(python-lockfile) = 0.10.2
Provides: bundled(python-progress) = 1.2
Provides: bundled(python-ipaddress) = 1.0.7
Provides: bundled(python-packaging) = 15.0
Provides: bundled(python-retrying) = 1.3.3

# requests bundles lots of things on its own
Provides: bundled(python-requests) = 2.6.0
Provides: bundled(python-chardet) = 2.3.0
# requests 2.6.0 uses urllib3 43b5b2b452e4344374de7d08ececcca495079b8d
# which is the 16th commit after tag 1.10.2
# https://github.com/shazow/urllib3/compare/1.10.2...1.10.3
Provides: bundled(python-urllib3) = 1.10.2
Provides: bundled(python-six) = 1.2.0
# ordered_dict.py from http://code.activestate.com/recipes/576693/, no versioning data
Provides: bundled(python-ordereddict)
Conflicts: python-pip <= 1.3.1-4.9.amzn1

%description -n python27-pip
Pip is a replacement for `easy_install
<http://peak.telecommunity.com/DevCenter/EasyInstall>`_.  It uses mostly the
same techniques for finding packages, so packages that were made
easy_installable should be pip-installable as well.

This package is meant to be used with Python 2.7.

%package -n python34-pip
Summary: A tool for installing and managing Python packages
BuildRequires: python34-devel
BuildRequires: python34-setuptools
Requires: python34(alternatives)
Requires: alternatives(addslave)
Requires: alternatives(removeslave)
Requires: alternatives(force)
Requires(preun): python34(alternatives)
Requires(preun): alternatives(removeslave)
Requires: ca-certificates
Requires: python34-setuptools

# Packages bundled/vendored by pip
# Rationale: https://github.com/pypa/pip/blob/develop/pip/_vendor/README.rst
# Versions are listed in pip/_vendor/vendor.txt
Provides: bundled(python-distlib) = 0.2.0
Provides: bundled(python-html5lib) = 0.999
Provides: bundled(python-six) = 1.9.0
Provides: bundled(python-colorama) = 0.3.3
Provides: bundled(python-CacheControl) = 0.11.2
Provides: bundled(python-lockfile) = 0.10.2
Provides: bundled(python-progress) = 1.2
Provides: bundled(python-ipaddress) = 1.0.7
Provides: bundled(python-packaging) = 15.0
Provides: bundled(python-retrying) = 1.3.3

# requests bundles lots of things on its own
Provides: bundled(python-requests) = 2.6.0
Provides: bundled(python-chardet) = 2.3.0
# requests 2.6.0 uses urllib3 43b5b2b452e4344374de7d08ececcca495079b8d
# which is the 16th commit after tag 1.10.2
# https://github.com/shazow/urllib3/compare/1.10.2...1.10.3
Provides: bundled(python-urllib3) = 1.10.2
Provides: bundled(python-six) = 1.2.0
# ordered_dict.py from http://code.activestate.com/recipes/576693/, no versioning data
Provides: bundled(python-ordereddict)
Conflicts: python-pip <= 1.3.1-4.9.amzn1

%description -n python34-pip
Pip is a replacement for `easy_install
<http://peak.telecommunity.com/DevCenter/EasyInstall>`_.  It uses mostly the
same techniques for finding packages, so packages that were made
easy_installable should be pip-installable as well.

This package is meant to be used with Python 3.4.

%prep
%setup -q -n %{upstream_name}-%{version}
# Amazon patches
%patch0 -p1
%patch1 -p1

# Unbundle the certificate bundle from mozilla in vendored requests.
rm -v %{upstream_name}/_vendor/requests/cacert.pem

%build
rm -rf %{py26builddir}
mkdir -p %{py26builddir}
cp -a * %{py26builddir}
pushd %{py26builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python26} setup.py build 
popd

rm -rf %{py27builddir}
mkdir -p %{py27builddir}
cp -a * %{py27builddir}
pushd %{py27builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python27} setup.py build 
popd

rm -rf %{py34builddir}
mkdir -p %{py34builddir}
cp -a * %{py34builddir}
pushd %{py34builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python34} setup.py build 
popd

%install
rm -rf %{buildroot}

pushd %{py26builddir}
%{__python26} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd

pushd %{py27builddir}
%{__python27} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd

pushd %{py34builddir}
%{__python34} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd
# The unversioned pip symlink is managed by alternatives.
%{__rm} %{buildroot}/%{_bindir}/pip

# Provide legacy python-pip and pip-python binaries for python26 only
ln -s pip-2.6 %{buildroot}/%{_bindir}/pip-python
ln -s pip-2.6 %{buildroot}/%{_bindir}/python-pip

rm -f %{buildroot}/%{_bindir}/pip2


mv %{buildroot}/%{_bindir}/pip{2.6,-2.6}

%__python26_shebang_path %{buildroot}%{python26_sitelib}


mv %{buildroot}/%{_bindir}/pip{2.7,-2.7}

%__python27_shebang_path %{buildroot}%{python27_sitelib}

rm -f %{buildroot}/%{_bindir}/pip3

mv %{buildroot}/%{_bindir}/pip{3.4,-3.4}

%__python34_shebang_path %{buildroot}%{python34_sitelib}

%check
%if %{with tests}
%endif

%clean
rm -rf %{buildroot}
rm -rf %{py26builddir}
rm -rf %{py27builddir}
rm -rf %{py34builddir}

%triggerin -n python26-pip -- python26
# Refresh alternatives when updating python26-pip or python26.
%{_sbindir}/update-alternatives \
  --force \
  --update python %{_bindir}/python2.6 \
  --addslave %{_bindir}/%{upstream_name} %{upstream_name} %{_bindir}/%{upstream_name}-2.6 \
  || :

%preun -n python26-pip
if [ $1 -eq 0 ]; then
  %{_sbindir}/update-alternatives \
    --update python %{_bindir}/python2.6 \
    --removeslave %{upstream_name} \
 || :
fi

%triggerin -n python27-pip -- python27
# Refresh alternatives when updating python27-pip or python27.
%{_sbindir}/update-alternatives \
  --force \
  --update python %{_bindir}/python2.7 \
  --addslave %{_bindir}/%{upstream_name} %{upstream_name} %{_bindir}/%{upstream_name}-2.7 \
  || :

%preun -n python27-pip
if [ $1 -eq 0 ]; then
  %{_sbindir}/update-alternatives \
    --update python %{_bindir}/python2.7 \
    --removeslave %{upstream_name} \
 || :
fi

%triggerin -n python34-pip -- python34
# Refresh alternatives when updating python34-pip or python34.
%{_sbindir}/update-alternatives \
  --force \
  --update python %{_bindir}/python3.4 \
  --addslave %{_bindir}/%{upstream_name} %{upstream_name} %{_bindir}/%{upstream_name}-3.4 \
  || :

%preun -n python34-pip
if [ $1 -eq 0 ]; then
  %{_sbindir}/update-alternatives \
    --update python %{_bindir}/python3.4 \
    --removeslave %{upstream_name} \
 || :
fi

%files -n python26-pip
%doc PKG-INFO docs
%{python26_sitelib}/*
%attr(755,root,root) %{_bindir}/pip-2.6
%{_bindir}/pip-python
%{_bindir}/python-pip
%ghost %{_bindir}/%{upstream_name}

%files -n python27-pip
%doc PKG-INFO docs
%{python27_sitelib}/*
%attr(755,root,root) %{_bindir}/pip-2.7
%ghost %{_bindir}/%{upstream_name}

%files -n python34-pip
%doc PKG-INFO docs
%{python34_sitelib}/*
%attr(755,root,root) %{_bindir}/pip-3.4
%ghost %{_bindir}/%{upstream_name}

%changelog
* Thu Aug 6 2015 Ian Weller <iweller@amazon.com>
- Mark bundled packages and remove vendored ssl_match_hostname

* Fri Jun 5 2015 Sean Kelly <seankell@amazon.com>
- Remove CA bundle from vendored requests.

* Thu Jun 4 2015 Sean Kelly <seankell@amazon.com>
- Update to 6.1.1

* Thu Mar 12 2015 Rodrigo Novo <rodarvus@amazon.de>
- Update to 6.0.8; Add python34 subpackage

* Wed Sep 17 2014 Rodrigo Novo <rodarvus@amazon.com>
- Build for multiple pythons

* Sun Aug 4 2013 Cristian Gafton <gafton@amazon.com>
- import source package EPEL6/python-pip-1.3.1-4.el6

* Tue Jul 16 2013 Toshio Kuratomi <toshio@fedoraproject.org> - 1.3.1-4
- Fix for CVE 2013-2099

* Thu May 23 2013 Tim Flink <tflink@fedoraproject.org> - 1.3.1-3
- undo python2 executable rename to python-pip. fixes #958377
- fix summary to match upstream

* Mon May 13 2013 Cristian Gafton <gafton@amazon.com>
- import source package EPEL6/python-pip-1.3.1-1.el6

* Mon May 06 2013 Kevin Kofler <Kevin@tigcc.ticalc.org> - 1.3.1-2
- Fix main package Summary, it's for Python 2, not 3 (#877401)

* Fri Apr 26 2013 Jon Ciesla <limburgher@gmail.com> - 1.3.1-1
- Update to 1.3.1, fix for CVE-2013-1888.

* Sat Feb 23 2013 Lee Trager <ltrager@amazon.com>
- Conditionalize Python3 support
- import source package F18/python-pip-1.2.1-2.fc18
- setup complete for package python-pip

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Oct 09 2012 Tim Flink <tflink@fedoraproject.org> - 1.2.1-2
- Fixing files for python3-pip

* Thu Oct 04 2012 Tim Flink <tflink@fedoraproject.org> - 1.2.1-1
- Update to upstream 1.2.1
- Change binary from pip-python to python-pip (RHBZ#855495)
- Add alias from python-pip to pip-python, to be removed at a later date

* Tue May 15 2012 Tim Flink <tflink@fedoraproject.org> - 1.1.0-1
- Update to upstream 1.1.0

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sat Oct 22 2011 Tim Flink <tflink@fedoraproject.org> - 1.0.2-1
- update to 1.0.2 and added python3 subpackage

* Thu Jul 21 2011 Cristian Gafton <gafton@amazon.com>
- import source package EPEL6/python-pip-0.8-1.el6
- import source package EPEL6/python-pip-0.7.2-1.el6

* Tue Jul 19 2011 Cristian Gafton <gafton@amazon.com>
- setup complete for package python-pip

* Wed Jun 22 2011 Tim Flink <tflink@fedoraproject.org> - 0.8.3-1
- update to 0.8.3 and project home page

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Dec 20 2010 Luke Macken <lmacken@redhat.com> - 0.8.2-1
- update to 0.8.2 of pip

* Mon Aug 30 2010 Peter Halliday <phalliday@excelsiorsystems.net> - 0.8-1
- update to 0.8 of pip

* Thu Jul 22 2010 David Malcolm <dmalcolm@redhat.com> - 0.7.2-5
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Wed Jul 7 2010 Peter Halliday <phalliday@excelsiorsystems.net> - 0.7.2-1
- update to 0.7.2 of pip

* Sun May 23 2010 Peter Halliday <phalliday@excelsiorsystems.net> - 0.7.1-1
- update to 0.7.1 of pip

* Fri Jan 1 2010 Peter Halliday <phalliday@excelsiorsystems.net> - 0.6.1.4
- fix dependency issue

* Tue Dec 18 2009 Peter Halliday <phalliday@excelsiorsystems.net> - 0.6.1-2
- fix spec file

* Mon Dec 17 2009 Peter Halliday <phalliday@excelsiorsystems.net> - 0.6.1-1
- upgrade to 0.6.1 of pip

* Mon Aug 31 2009 Peter Halliday <phalliday@excelsiorsystems.net> - 0.4-1
- Initial package
